import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Vector;

import javax.microedition.io.Connector;

import com.nttdocomo.io.BufferedReader;
import com.nttdocomo.ui.*;

public class Map implements Common{
	
	//萔̐錾----------------------------------------
	//private static final int COL = 10;	//1ʂɕ\łZ
	//private static final int ROW = 10;		
	
	//摜֌Wϐ錾--------------------------------------
	public static Image[] mapImg = new Image[3];		//MAP摜
	private static MediaImage Mimage;
	
	
	//}bv֌Wϐ錾------------------------------------
	//private Map m;
	public int no;			//Map̒ʂԍ
	public String name;		//Map̖O
	public int mCol;		//MapŜ̍s
	public int mRow;		
	public int Width;		//MapŜ̉isNZj
	public int Height;	
	
	public Vector charas = new Vector();	//MapɂLN^[
	public Vector objevents = new Vector();	//Mapɂ̃Cxg
	public Vector events = new Vector();	//MapɂCxg
	
	public int chNum = 0;	//MapɂNPC
	public int objNum = 0;	//Mapɂ镨Cxg
	public int trNum = 0;	//Mapɂ󑍐
	
	private int[][] map;
	
	public int enCount;	//GJEg
	public int batBG;	//퓬wi
	
	public WorldPointSet wordPointset = new WorldPointSet();
	
	//FPS\----------------------------------
	private static long bTime = 0;
	private static int nFPS = 0; 
	private static int sFPS = 0;
//-------------------------------------------------------------------------------------------------------
	public Map(int mapNo, int eventNo){
		
		String fileName = "";
		int nNo = mapNo;
		
		//}bvǂݍ
		if(nNo >= 1000){
			fileName = Integer.toString(nNo) + ".map"; 
		}else if (nNo >= 100){
			fileName = "0" + Integer.toString(nNo) + ".map"; 
		}else if (nNo >= 10){
			fileName = "00" + Integer.toString(nNo) + ".map"; 
		}else{
			fileName = "000" + Integer.toString(nNo) + ".map"; 
		}
		LoadMap(fileName);
		
		//Cxgǂݍ
		nNo = eventNo;
		if(nNo >= 1000){
			fileName = Integer.toString(nNo) + ".evt"; 
		}else if (nNo >= 100){
			fileName = "0" + Integer.toString(nNo) + ".evt"; 
		}else if (nNo >= 10){
			fileName = "00" + Integer.toString(nNo) + ".evt"; 
		}else{
			fileName = "000" + Integer.toString(nNo) + ".evt"; 
		}
		LoadEvent((fileName));
		
		no = nNo;
		
		//}bv
		InitMap();
		
		//}bvZbg
		name = NameSet(mapNo);
		
	}
	
//-------------------------------------------------------------------------------------------------------	
	public static void InitMap(){
		
		//}bv摜̓ǂݍ݁ǐĂяô
		//mapImg = new Image[3];
		if(mapImg[0] == null){
			try{
				Mimage = MediaManager.getImage("resource:///mapchip0.gif");
				Mimage.use();
				mapImg[0] = Mimage.getImage();
				Mimage = MediaManager.getImage("resource:///mapchip1.gif");
				Mimage.use();
				mapImg[1] = Mimage.getImage();
				Mimage = MediaManager.getImage("resource:///mapchip2.gif");
				Mimage.use();
				mapImg[2] = Mimage.getImage();
			}catch(Exception e){
				System.out.println("O܂BI܂B");
				return;
			}
		}
	}	

//-------------------------------------------------------------------------------------------------------
	public  void Draw(Graphics g, int offsetX, int offsetY){
		//ItZbgɕ`͈͂߂-----------
		int firstCellX = PixToCell(offsetX);
		int lastCellX = firstCellX + PixToCell(Cmn.WIDTH) + 1;
		int firstCellY = PixToCell(offsetY);
		int lastCellY = firstCellY + PixToCell(Cmn.HEIGHT) + 1;
		
		//`͈͂Map̑傫傫ȂȂ悤
		if(lastCellX > mCol) lastCellX = mCol;
		if(lastCellY > mRow) lastCellY = mRow;
		
		//Map`揈
		//g.setColor(g.getColorOfName(g.BLACK));
		//g.fillRect(0, 0, Cmn.WIDTH, Cmn.HEIGHT);
		
		//int drawID;
		
		for (int i = firstCellY; i < lastCellY; i++){
			for (int j = firstCellX; j < lastCellX; j++){
				//map̒lɉĉ摜`
				int drawID = map[i][j];
				int cx = ((drawID - (drawID / 96 * 96)) % TURN_POINT) * CHA_SIZE;
		    	int cy = ((drawID - (drawID / 96 * 96)) / TURN_POINT) * CHA_SIZE;
				
				g.drawImage(mapImg[drawID / 96], CellToPix(j) - offsetX, CellToPix(i) - offsetY,
						cx, cy, CHA_SIZE, CHA_SIZE);
			}
		}
		

    	
		//Cxg̕`------------------------------------------------------------
		for(int n = 0; n < events.size(); n++){
			Event eve = (Event)events.elementAt(n);
			int ex = eve.x;
			int ey = eve.y;
			int chipID;
			if(eve instanceof TreEvent){
	    		TreEvent tEve = (TreEvent)eve;
	    		chipID = tEve.chipNo;
			}else{
				chipID = eve.chipNo;
			}
			int cx = ((chipID - (chipID / 96 * 96)) % TURN_POINT) * CHA_SIZE;
			int cy = ((chipID - (chipID / 96 * 96)) / TURN_POINT) * CHA_SIZE;
			int dx = CellToPix(ex);
			int dy = CellToPix(ey);
			
			if((dx - offsetX > - CHA_SIZE) && (dy - offsetY > - CHA_SIZE) &&
	    			(dx - offsetX < Cmn.WIDTH) && (dy - offsetY < Cmn.HEIGHT)){
				g.drawImage(mapImg[chipID / 96], dx - offsetX, dy - offsetY,
						cx, cy, CHA_SIZE, CHA_SIZE);
			}
		}
		
		//S̃}bv`̏ꍇAړ|Cg̕`------------------------------------------------------------
		if(no >= Cmn.WORLD_MAP){
			wordPointset.DrawMovePoint(offsetX, offsetY, mapImg, g);
		}
		
		//̃Cxg̕`------------------------------------------------------------
		for(int n = 0; n < objevents.size(); n++){
			ObjEvent obje = (ObjEvent)objevents.elementAt(n);

			obje.Draw(g, offsetX, offsetY);
	
		}
		
		//LN^̕`----------------------------------------------------------
		for(int n = 0; n < charas.size(); n++){
			Chara chara = (Chara)charas.elementAt(n);

				chara.Draw(g, offsetX, offsetY);
	
		}
		
		//S̃}bv`̏ꍇA}bv̖O`------------------------------------------------------------
		if(no >= Cmn.WORLD_MAP){
			Cmn.DrawWin(0, Cmn.HEIGHT - 20, 120, 20, g);
			Cmn.DrawMessage(2, Cmn.HEIGHT - 2, name, 255, 255, 255, g);
		}
		
		//GJEgϓĂƂ̕\-----------------------------------------
		if(Cmn.encUp > 0 && Cmn.menuVisible == 0){
			Cmn.DrawWin(110, Cmn.HEIGHT - 20, 130, 20, g);
			Cmn.DrawMessage(112, Cmn.HEIGHT - 2, "GJEg㏸", 255, 255, 255, g);
		}else if(Cmn.encUp <= -100 && Cmn.menuVisible == 0){
			Cmn.DrawWin(110, Cmn.HEIGHT - 20, 130, 20, g);
			Cmn.DrawMessage(112, Cmn.HEIGHT - 2, "GJEgȂ", 255, 255, 255, g);
		}else if(Cmn.encUp < 0 && Cmn.menuVisible == 0){
			Cmn.DrawWin(110, Cmn.HEIGHT - 20, 130, 20, g);
			Cmn.DrawMessage(112, Cmn.HEIGHT - 2, "GJEg", 255, 255, 255, g);
		}
		
		//̃x܂ł̌ol\-----------------------------------------
		if(Cmn.showNext > 0 && Cmn.menuVisible == 0){
			for(int i = 0; i < Cmn.ptNum; i++){
				Cmn.DrawWin(i * Battle.ptW, 0, Battle.ptW, 34, g);
				
				//l\
				int nx = i * Battle.ptW;

				//EXP̕`------------------------------				
				int next = Battle.ptm[i].next - Battle.ptm[i].exp;
				if(next < 0) next = 0;
				
				Cmn.NumDraw(nx + (Battle.ptW - 6), 2, next);	
				g.drawImage(Cmn.sysImg, nx + 2, 2, 112, 0, 9, 10);
				
				//΂̕`------------------------------				
				for(int j = 0; j < 2; j++){
					if(j == 0){
						Cmn.stone.StoneList(Battle.ptm[i].eStone[0]);
					}else if(j == 1){
						Cmn.stone.StoneList(Battle.ptm[i].eStone[1]);
					}
					//EXP̕`------------------------------
					if(Cmn.stone.no > 0){
						next = Stone.UpExp(Cmn.stoneList[Battle.ptm[i].eStone[j]]) - Cmn.stoneExp[Battle.ptm[i].eStone[j]];
						if(next < 0) next = 0;
						Cmn.NumDraw(nx + (60 - 6), 12 + 10 * j, next);
						
						g.drawImage(Cmn.sysImg, nx + 2, 12 + 10 * j, 112, 0, 9, 10);
					}
					
				}
				
			}
		}
		
		//fobOf[^`---------------------------------------------------------
		if(Cmn.DEBUG_MODE == 1){
			Chara chara = (Chara)charas.elementAt(chNum);
			g.setColor(Graphics.getColorOfName(Graphics.WHITE));
			g.drawString(chara.GetX() + ", " + chara.GetY(), 0, 12);
			g.drawString((chara.GetpX()) + ", " + (chara.GetpY()), 0, 24);
			g.drawString(Integer.toString(no) + ", " + name, 0, Cmn.HEIGHT - 1);
			//g.drawString(Integer.toString(Cmn.stoneHaveList[0]), 0, Cmn.HEIGHT - 25);
			//g.drawString(Integer.toString(Cmn.stoneHaveList[1]), 0, Cmn.HEIGHT - 13);
			
			//g.drawString(chara.GetIsMoving() + "", 0, 36);
			
			//Cmn.DrawChara(100,100,'',255,255,255,g);
			
			nFPS++;
			if((System.currentTimeMillis() - bTime) >= 1000){
				sFPS = nFPS;
				nFPS = 0;
				bTime = System.currentTimeMillis();
			}
			g.drawString(Integer.toString(sFPS), 0, 36);
		}
		
	}
	
//-------------------------------------------------------------------------------------------------------		
	public  int IsHit(int x, int y){
		//}bv`bv5-8sڂ̃}bv`bv͂Ԃ
		if (map[y][x] >= 64 && map[y][x] < 127) {
            return 1;
        }
        
		//ق̃LԂiĂA摜ȂȂԂȂ
		for(int i = 0; i < charas.size(); i++){
			Chara chara = (Chara)charas.elementAt(i);
			if((chara.GetX() == x) && (chara.GetY() == y) &&( chara.charaNo[chara.actPage] != 0)){
				return 1;
			}
		}
		
		//ԂCxg
		for(int i = 0; i < events.size(); i++){
			Event eve = (Event)events.elementAt(i);
			if(eve.x == x && eve.y == y){
				return eve.isHit;
			}
		}
		for(int i = 0; i < objevents.size(); i++){
			ObjEvent oeve = (ObjEvent)objevents.elementAt(i);
			if(oeve.GetX() == x && oeve.GetY() == y){
				return oeve.isHit[oeve.actPage];
			}
		}
		
		//Ȃ΂ԂȂ
		return 0;
	}

//-------------------------------------------------------------------------------------------------------		
	/**
	 * LN^[̃}bvɒǉ
	 * @param chara
	 */

	public void AddChara(Chara chara){
		charas.addElement(chara);
		
	}

//-------------------------------------------------------------------------------------------------------		
	/**
	 * LN^[폜
	 * @param chara
	 */

	public void RemoveChara(Chara chara){
		charas.removeElement(chara);
		
	}
	
//-------------------------------------------------------------------------------------------------------		
	/**
	 * w肵WɃL邩ׂ
	 * @param x XW
	 * @param y YW
	 * @return Lꍇ͂charaAȂnull
	 */
	public Chara CharaCheck(int x, int y){
		for(int i = 0; i < charas.size(); i++){
			Chara chara = (Chara)charas.elementAt(i);
			if(chara.GetX() == x && chara.GetY() == y){
				return chara;
			}
		}
		
		return null;
	}
	
//-------------------------------------------------------------------------------------------------------		
	/**
	 * w肵WɃCxg邩ׂ
	 * @param x XW
	 * @param y YW
	 * @return Cxgꍇ͂eventAȂnull
	 */
	public Event EventCheck(int x, int y){
		for(int i = 0; i < events.size(); i++){
			Event eve = (Event)events.elementAt(i);
			if(eve.x == x && eve.y == y){
				return eve;
			}
		}
		
		return null;
	}

//-------------------------------------------------------------------------------------------------------		
	/**
	 * w肵Wɕ邩ׂ
	 * @param x XW
	 * @param y YW
	 * @return ꍇ͂eventAȂnull
	 */
	public ObjEvent ObjCheck(int x, int y){
		for(int i = 0; i < objevents.size(); i++){
			ObjEvent eve = (ObjEvent)objevents.elementAt(i);
			if(eve.GetX() == x && eve.GetY() == y){
				return eve;
			}
		}
		
		return null;
	}
	
//-------------------------------------------------------------------------------------------------------		
	/**
	 * }bvɎJnCxg邩𒲂ׂ
	 */
	public ObjEvent ObjCheckAutoAct(){
		for(int i = 0; i < objevents.size(); i++){
			ObjEvent eve = (ObjEvent)objevents.elementAt(i);
			if(eve.actCnd[eve.actPage] == ObjEvent.ACTCND_AUTO){
				return eve;
			}
		}
		
		return null;
	}
	
//-------------------------------------------------------------------------------------------------------		
	/**
	 * w肵CxgIuWFNg폜
	 */
	public void RemoveEvent(Event eve){
		events.removeElement(eve);
		
	}

//-------------------------------------------------------------------------------------------------------		
	/**
	 * MapŜ̃CxgtO`FbNčXVł͍̂XV
	 */
	public void RefleshEvt(){
		for(int i = 0; i < charas.size(); i++){
			Chara chara = (Chara)charas.elementAt(i);
			chara.CheckFlg();
			
		}
		for(int i = 0; i < objevents.size(); i++){
			ObjEvent obj = (ObjEvent)objevents.elementAt(i);
			obj.CheckFlg();
			
		}
		
		int befQueNum = Cmn.queNum;
		Cmn.que.QueReflesh();
		if(Cmn.queNum > befQueNum){
			Cmn.newQuest = 1;
		}
		
	}
	
//-------------------------------------------------------------------------------------------------------		
	//sNZPʂZPʂɕϊ
	//@ϊOsNZP
	//ߒl@ϊZP
	public static int PixToCell(int pix){
		int a;
		int r;
		
		if(pix == 0){
			return 0;
		}else{
			a = pix % CHA_SIZE;
			r = (pix - a) / CHA_SIZE;
			
			//if(a > 0) r++;
			
			return r;
		}
	}

//	-------------------------------------------------------------------------------------------------------		
	//sNZPʂZPʂɕϊ
	//@ϊOsNZP
	//ߒl@ϊZP
	public static int CellToPix(int cell){
		return cell * CHA_SIZE;
		
	}
	
//------------------------------------------------------------------------------------------------------		
	/**
	 * t@CMapǂݍ
	 * @param fileName ǂݍMap̃t@C
	 */
	private void LoadMap(String fileName){
		try{
			
			InputStream in = getClass().getResourceAsStream(fileName);
			
			//MapNoǂݍ
			no = in.read();

			//GJEgǂݍ
			enCount = in.read();
			
			//퓬BGǂݍ
			batBG = in.read();
			
			// sE񐔂ǂݍ
			mRow = in.read();
			mCol = in.read();
			
			Width = mCol * CHA_SIZE;
			Height = mRow * CHA_SIZE;

            // }bvǂݍ
            map = new int[mRow][mCol];
            for (int i = 0; i < mRow; i++) {
                for (int j = 0; j < mCol; j++) {
                    map[i][j] = in.read();
                }
            }
			
			
			
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
//------------------------------------------------------------------------------------------------------		
	/**
	 * t@CCxgǂݍ
	 * @param fileName ǂݍރt@C
	 */
	private void LoadEvent(String fileName){
		try{
			InputStream in = Connector.openInputStream("resource:///" + fileName);
			InputStreamReader inr = new InputStreamReader(in);
			BufferedReader br = new BufferedReader(inr);		
			
			String line;
			
			while((line = br.readLine()) != null){
				//s͓ǂݔ΂
				if(line.equals("")) continue;
				//Rgs͓ǂݔ΂
				if(line.startsWith("#")) continue;
				
				
				//Cxg擾
				//Cxg^Cv擾ăCxgƂɏ
				String eventType = StrToken(line, ',', 1);
				
				if(eventType.equals("CHARA")){	//LN^[Cxg
					MakeChara(line);
				}else if(eventType.equals("OBJ")){		//Cxg
					MakeObj(line);
				}else if(eventType.equals("TREASURE")){		//
					MakeTreasure(line);
				}else if(eventType.equals("DOOR")){		//
					MakeDoor(line);
				}else if(eventType.equals("MOVE")){		//ړ
					MakeMove(line);
				}
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
//-----------------------------------------------------------------------------------------------------		
	/**
	 * LN^[쐬
	 * @param st Cxgf[^
	 */
	private void MakeChara(String st){
		//Cxg̍W
		int x = Integer.parseInt(StrToken(st, ',', 2));
		int y = Integer.parseInt(StrToken(st, ',', 3));
		
		//LN^ԍ
		int[] charaNo = new int[4];
		//
		int[] dir = new int[4];
		//ړ^Cv
		int[] moveType = new int[4];
		//ړx
		int[] speed = new int[4];
        //bZ[W
		String msg[] = new String[4];
		//tO
        int[] flg = new int[3];
        
        charaNo[0] = Integer.parseInt(StrToken(st, ',', 4));
        dir[0] =Integer.parseInt(StrToken(st, ',', 5));
        moveType[0] = Integer.parseInt(StrToken(st, ',', 6));
        speed[0] =  Integer.parseInt(StrToken(st, ',', 7));
        msg[0] = StrToken(st, ',', 8);
        
        for(int i = 0; i < 3; i++){
        	flg[i] = Integer.parseInt(StrToken(st, ',', 9 + i * 6));
	        charaNo[i + 1] = Integer.parseInt(StrToken(st, ',', 10 + i * 6));
	        dir[i + 1] =Integer.parseInt(StrToken(st, ',', 11 + i * 6));
	        moveType[i + 1] = Integer.parseInt(StrToken(st, ',', 12 + i * 6));
	        speed[i + 1] =  Integer.parseInt(StrToken(st, ',', 13 + i * 6));
	        msg[i + 1] = StrToken(st, ',', 14 + i * 6);
        }
        
		//LN^쐬
		Chara c = new Chara(x, y, charaNo[0], dir[0], moveType[0], this, speed[0],
							flg[0], charaNo[1], dir[1], moveType[1], speed[1],
							flg[1], charaNo[2], dir[2], moveType[2], speed[2],
							flg[2], charaNo[3], dir[3], moveType[3], speed[3]);
		
		//bZ[Wo^
		c.SetMsg(msg[0], msg[1], msg[2], msg[3]);
		
		//LN^̓o^
		charas.addElement(c);
		
		chNum++;	//LN^𑝂₷
	}
	
//-----------------------------------------------------------------------------------------------------		
	/**
	 * ̃Cxg쐬
	 * @param st Cxgf[^
	 */
	private void MakeObj(String st){
		//Cxg̍W
		int x = Integer.parseInt(StrToken(st, ',', 2));
		int y = Integer.parseInt(StrToken(st, ',', 3));
		
		//LN^ԍ
		int[] charaNo = new int[4];
		//蔻
		int[] isHit = new int[4];
		//
		int[] actCnd = new int[4];
        //bZ[W
		String msg[] = new String[4];
		//tO
        int[] flg = new int[3];
        
        charaNo[0] = Integer.parseInt(StrToken(st, ',', 4));
        isHit[0] =Integer.parseInt(StrToken(st, ',', 5));
        actCnd[0] =Integer.parseInt(StrToken(st, ',', 6));
        msg[0] = StrToken(st, ',', 7);
        
        for(int i = 0; i < 3; i++){
        	flg[i] = Integer.parseInt(StrToken(st, ',', 8 + i * 5));
	        charaNo[i + 1] = Integer.parseInt(StrToken(st, ',', 9 + i * 5));
	        isHit[i + 1] =Integer.parseInt(StrToken(st, ',', 10 + i * 5));
	        actCnd[i + 1] =Integer.parseInt(StrToken(st, ',', 11 + i * 5));
	        msg[i + 1] = StrToken(st, ',', 12 + i * 5);
        }
        
		//Cxg쐬
		ObjEvent c = new ObjEvent(this, x, y, charaNo[0], isHit[0], actCnd[0],
							flg[0], charaNo[1], isHit[1], actCnd[1],
							flg[1], charaNo[2], isHit[2], actCnd[2],
							flg[2], charaNo[3], isHit[3], actCnd[3]);
		
		//bZ[Wo^
		c.SetMsg(msg[0], msg[1], msg[2], msg[3]);
		
		//Cxg̓o^
		objevents.addElement(c);
		
		objNum++;	//LN^𑝂₷
	}
	
//------------------------------------------------------------------------------------------------------		
	
	private void MakeTreasure(String st){
		//	Cxg̍W
		int x = Integer.parseInt(StrToken(st, ',', 2));
		int y = Integer.parseInt(StrToken(st, ',', 3));
		
		//ID
		int id = trNum;
		
		//ACeID
		int itemName = Integer.parseInt(StrToken(st, ',', 6));
		
		
		
		//󔠃Cxg쐬
		TreEvent t = new TreEvent(x, y, TreEvent.TRE_CLOSE, id, itemName);
		
		//̊J󋵂i[
		t.nOpen = Cmn.trOpen[no][trNum];
		
		//󂪊JĂ`bvύX
		if(t.nOpen == TreEvent.OPEN){
			t.chipNo = TreEvent.TRE_OPEN;
		}
		
		//o^
		events.addElement(t);
		
		trNum++;	//𑝂₷
	}

//------------------------------------------------------------------------------------------------------		
	private void MakeDoor(String st){
		//Ƃт̍W
		int x = Integer.parseInt(StrToken(st, ',', 2));
		int y = Integer.parseInt(StrToken(st, ',', 3));
		
		//ƂтCxg̍쐬
		DoorEvent d = new DoorEvent(x, y, 195);
		
		//Ƃтo^
		events.addElement(d);
	}
	
//-----------------------------------------------------------------------------------------------------		
	private void MakeMove(String st){
		//ړCxg̏ꏊ
		int x = Integer.parseInt(StrToken(st, ',', 2));
		int y = Integer.parseInt(StrToken(st, ',', 3));
		
		//`bvԍ
		int chipNo = Integer.parseInt(StrToken(st, ',', 4));
		
		//ړMapԍ
		int destMap = Integer.parseInt(StrToken(st, ',', 5));
		
		//ړ̍W
		int dx = Integer.parseInt(StrToken(st, ',', 6));
		int dy = Integer.parseInt(StrToken(st, ',', 7));
		
		//ړ̃GtFNg
		int efe = Integer.parseInt(StrToken(st, ',', 8));
		
		//ړCxg쐬
		MoveEvent mv = new MoveEvent(x, y, chipNo, destMap, dx, dy, efe);
		
		//ړCxgo^
		events.addElement(mv);
		
	}
	
//------------------------------------------------------------------------------------------------------		
	/**
	 * w肵w肵ŋ؂Aw肵؂ꏊ̕Ԃ
	 * @param str Ŝ̕
	 * @param flgStr 
	 * @param num o؂ʒu
	 * @return oꂽ
	 */
	private static String StrToken(String str,char flgStr, int num){
		
		String oStr = str;		//؂O̕
		String ResultStr = "null";	//؂ꂽʂi[
		int i = -1;
		int j = 0, sepNum = 0;	//؂ꂽ
		
		//؂O̍̕ŌłȂ΁A}
		if(oStr.charAt(oStr.length() - 1) != flgStr) oStr += flgStr;
		
		//؂鐔vZ
		i = oStr.indexOf(flgStr);
		while(i != -1){
			sepNum++;
			j = i + 1;
			i = oStr.indexOf(flgStr, j);			
		}
		
		if(sepNum < num || num <1) return "null";
		
		//el̏
		j = 0;
		sepNum = 1;
		i = oStr.indexOf(flgStr);
		while(i != -1){
			if(sepNum == num){
				ResultStr = oStr.substring(j, i);
			}
			j = i + 1;
			i = oStr.indexOf(flgStr, j);
			sepNum++;
		}
		return ResultStr;
		
	}
	
//------------------------------------------------------------------------------------------------------		
	/**
	 * }bvԍ疼OoZbg
	 */
	public static String NameSet(int no){
		switch(no){
		case 0: return "";
		case 1: return "tB[h";
		case 2: return "͂߂Ă̂ǂ@aP";
		case 3: return "͂߂Ă̂ǂ@aQ";
		case 4: return "Rオ铃@Pe";
		case 5: return "Rオ铃@Qe";
		case 6: return "Rオ铃@Re";
		case 7: return "̊X";
		case 8: return "Â̈ˁ@aP";
		case 9: return "Â̈ˁ@aQ";
		case 10: return "ȑ";
		case 11: return "[X";
		case 12: return "OgA@Pe";
		case 13: return "OgA@Qe";
		case 14: return "OgA@Re";
		case 15: return "Ȓ";
		case 16: return "؂̓@Pe";
		case 17: return "؂̓@Qe";
		case 18: return "؂̓@Re";
		case 19: return "؂̓@Se";
		case 20: return "؂̓@Te";
		case 21: return "un@aT";
		case 22: return "un@aS";
		case 23: return "un@aR";
		case 24: return "un@aQ";
		case 25: return "un@aP";
		case 26: return "Â";
		case 27: return "̓A@aP";
		case 28: return "̓A@aQ";
		case 29: return "̓A@aR";
		case 30: return "@Pe";
		case 31: return "@Qe";
		case 32: return "@Re";
		case 33: return "@Se";
		case 34: return "@Te";
		case 35: return "̉BʘH@aP";
		case 36: return "̉BʘH@aQ";
		case 37: return "̉BʘH@aR";
		case 38: return "̉BʘH@aS";
		case 39: return "̉BʘH@aT";
		case 40: return "̉BʘH@aU";
		case 41: return "̉BʘH@aV";
		case 42: return "̉BʘH@aW";
		case 43: return "Rx̑";
		case 44: return "k̓";
		case 45: return "k̓";
		case 46: return "k̓";
		case 47: return "k̓";
		case 48: return "k̓";
		case 49: return "k̓EBʘH";
		case 50: return "̑";
		case 51: return "֏";
		case 52: return "򑐂̓A@aP";
		case 53: return "򑐂̓A@aQ";
		case 54: return "򑐂̓A@aR";
		case 55: return "򑐂̓A@aS";
		case 56: return "~X";
		case 57: return "͂̓A@aP";
		case 58: return "̈";
		case 59: return "͂̓A@aP";
		case 60: return "͂̓A@aQ";
		case 61: return "^ӂ̓A";
		case 62: return "l匳f̓A";
		case 63: return "^ӂ̓A@aP";
		case 64: return "^ӂ̓A@aQ";
		case 65: return "l匳f̓A@aP";
		case 66: return "l匳f̓A@aQ";
		case 67: return "̈Ձ@Pe";
		case 68: return "̈Ձ@aP";
		case 69: return "̈Ձ@aP";
		case 70: return "̈Ձ@aQ";
		case 71: return "̈Ձ@aR";
		case 72: return "̈Ձ@aS";
		case 73: return "̈Ձ@aT";
		case 74: return "ΎR̒";
		case 75: return "ΎR";
		case 76: return "ΎR";
		case 77: return "ΎR";
		case 78: return "ΎR";
		case 79: return "ΎR";
		case 80: return "ΎR@PF";
		case 81: return "ΎR@aP";
		case 82: return "ΎR@aQ";
		case 83: return "ΎR@aR";
		case 84: return "";
		case 85: return "̓A";
		case 86: return "[̓";
		case 87: return "CꓴA@aP";
		case 88: return "CꓴA@aQ";
		case 89: return "CꓴA@aR";
		case 90: return "CꓴA@aS";
		case 91: return "CꓴA@aT";
		case 92: return "A@aP";
		case 93: return "A@aQ";
		case 94: return "A@aR";
		case 95: return "A@aS";
		case 96: return "A@aT";
		case 97: return "A@aU";
		case 98: return "A@aP";
		case 99: return "A@aQ";
		case 100: return "A@aR";
		case 101: return "A@aS";
		case 102: return "A@aT";
		case 103: return "A@aU";
		case 104: return "̒@ŉw";
		case 105: return "̒@Qe";
		case 106: return "̒@Re";
		case 107: return "̒@Se";
		case 108: return "̒@Te";
		case 109: return "̒@Ue";
		case 110: return "̒@Ve";
		case 111: return "̒@w";
		case 112: return "̒@Xe";
		case 113: return "̒@POe";
		case 114: return "̒@PPe";
		case 115: return "̒@PQe";
		case 116: return "̒@PRe";
		case 117: return "̒@PSe";
		case 118: return "̒@w";
		case 119: return "V";
		case 120: return "_̏@Pe";
		case 121: return "_̏@Qe";
		case 122: return "_̏@aP";
		case 123: return "_̏@aQ";
		case 124: return "_̏@aR";
		case 125: return "_̏@aS";
		case 126: return "_̏@aT";
		case 127: return "_̏@aU";
		case 128: return "_̏@aV";
		case 129: return "_̏@aW";
		case 130: return "ӂƂ̒";
		case 131: return "Ẻ@R[";
		case 132: return "Ẻ@R[";
		case 133: return "Ẻ@R[";
		case 134: return "Ẻ@R[A";
		case 135: return "Ẻ@R[A";
		case 136: return "Ẻ@R";
		case 137: return "Ẻ@R";
		case 138: return "Ẻ@RA";
		case 139: return "Ẻ@RA";
		case 140: return "Ẻ@Rt";
		case 141: return "Ẻ@R";
		case 142: return "H̒";
		case 143: return "̐X";
		case 144: return "_̐";
		case 145: return "_̐";
		case 146: return "̓A";
		case 147: return "_̍";
		case 148: return "_̍@Pe@ubN";
		case 149: return "_̍@Pe@쐼ubN";
		case 150: return "_̍@Pe@kubN";
		case 151: return "_̍@Pe@kubN";
		case 152: return "_̍@Pe@쓌ubN";
		case 153: return "_̍@Qe";
		case 154: return "_̍@Re";
		case 155: return "_̍@Se";
		case 156: return "_̍@Te";
		case 157: return "_̍@Ue";
		case 158: return "_̍@Ve";
		case 159: return "_̊";
		case 160: return "GfBOp}bv";
		case 161: return "n̓A";
		case 162: return "n󓴂̒";
		case 163: return "n󓴁@aQ";
		case 164: return "n󓴁@aR@r][";
		case 165: return "n󓴁@aR@v][";
		case 166: return "n󓴁@aR@m][";
		case 167: return "n󓴁@aR@d][";
		case 168: return "n󓴁@aR";
		case 169: return "n󓴁@aS@k][";
		case 170: return "n󓴁@aS@q][";
		case 171: return "n󓴁@aS";
		case 172: return "n󓴁@aT";
		case 173: return "n󓴁@aU";
		case 174: return "n󓴁@aV@x";
		case 175: return "n󓴁@aW";
		case 176: return "n󓴁@aX";
		case 177: return "n󓴁@aPO";
		case 178: return "n󓴁@aPP";
		case 179: return "n󓴁@aPQ";
		case 180: return "n󓴁@aPR";
		case 181: return "n󓴁@aPR";
		case 182: return "n󓴁@aPS";
		case 183: return "n󓴁@aPS@ł̊";
		case 184: return "n󓴁@aPT";
		case 185: return "┑D";
		case 186: return "┑D@Pe";
		case 187: return "┑D@aP";
		case 188: return "┑D@aQ";
		case 189: return "┑D@aR";
		case 190: return "┑D@aS";
		case 191: return "┑D@D";
		
		case 9000: return "͂܂̂ق";
		case 9001: return "Ân";
		case 9002: return "Rxn";
		case 9003: return "̒n";
		case 9004: return "Rn";
		case 9005: return "VE";
		
		default:
			return "ȂȂ";
		}
		
	}
	
//------------------------------------------------------------------------------------------------------		
}
